; Cross Platform Music Player
; Atari 8-bit version
; /Mic, 2011


.EQU XPMP_AUDF1 	$D200
.EQU XPMP_AUDC1 	$D201
.EQU XPMP_AUDIOCTL 	$D208


.DEFINE XPMP_ENABLE_CHANNEL_A
.DEFINE XPMP_ENABLE_CHANNEL_B
.DEFINE XPMP_ENABLE_CHANNEL_C
.DEFINE XPMP_ENABLE_CHANNEL_D

.EQU CMD_NOTE   $00
.EQU CMD_REST	$0C
.EQU CMD_REST2	$0D
.EQU CMD_VOLUP	$0E
.EQU CMD_OCTAVE $10
.EQU CMD_DUTY   $20
.EQU CMD_VOL2   $30
.EQU CMD_OCTUP  $40
.EQU CMD_OCTDN  $50
.EQU CMD_NOTE2	$60
.EQU CMD_PULSE	$70
.EQU CMD_ARPOFF $90
.EQU CMD_FILTER $93
.EQU CMD_PULMAC	$95
.EQU CMD_JSR	$96
.EQU CMD_RTS	$97
.EQU CMD_LEN	$9A
.EQU CMD_WRMEM  $9B
.EQU CMD_WRPORT $9C
.EQU CMD_CBOFF  $E0
.EQU CMD_CBONCE $E1
.EQU CMD_CBEVNT $E2
.EQU CMD_CBEVVC $E3
.EQU CMD_CBEVVM $E4
.EQU CMD_CBEVOC $E5
.EQU CMD_DETUNE $ED
.EQU CMD_MULT	$EF
.EQU CMD_VOLSET $F0
.EQU CMD_VOLMAC $F1
.EQU CMD_DUTMAC $F2
.EQU CMD_PORMAC $F3
.EQU CMD_PANMAC $F4
.EQU CMD_VIBMAC $F5
.EQU CMD_SWPMAC $F6
.EQU CMD_VSLMAC $F7
.EQU CMD_ARPMAC $F8
.EQU CMD_JMP    $F9
.EQU CMD_DJNZ   $FA
.EQU CMD_LOPCNT $FB
.EQU CMD_APMAC2 $FC
.EQU CMD_J1	$FD
.EQU CMD_END    $FF

.EQU EFFECT_DISABLED 0

; Zeropage RAM addresses used by the player
.EQU xpmp_songTbl	$83
.EQU xpmp_songTblLo $83
.EQU xpmp_songTblHi $84
.EQU xpmp_songNum 	$85
.EQU xpmp_dataPtr 	$87
.EQU xpmp_dataPtrLo $87
.EQU xpmp_dataPtrHi $88
.EQU xpmp_tempZp1	$89
.EQU xpmp_tempZp2	$8A
.EQU xpmp_tempZp3	$8B
.EQU xpmp_freqTblLo	$8C
.EQU xpmp_freqTblHi	$8D

.STRUCT xpmp_channel_t
dataPtr		dw
dataPos		dw
delay		dw
delayHi		db	; Note delays are 24 bit unsigned fixed point in 16.8 format
note		db
noteOffs	db
octave		db
freq		dw
volume		db
volOffs		db
volOffsLatch	db
freqOffs	dw
freqOffsLatch	dw
detune		dw 
vMac		db
vMacPtr		dw
vMacPos		db
dtMac		db
dtMacPtr	dw
dtMacPos	db
enMac		db
enMacPtr	dw
enMacPos	db
epMac		db
epMacPtr	dw
epMacPos	db
mpMac		db
mpMacPtr	dw
mpMacDelay	db
loop1		db
loop2		db
loopIdx		db
cbEvnote	dw
returnAddr	dw
oldPos		dw
delayLatch	dw
delayLatch2	db
audc		db
mode		db
.ENDST


XPMP_VARIABLES:
.DSTRUCT xpmp_channel0,xpmp_channel_t,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0
.DSTRUCT xpmp_channel1,xpmp_channel_t,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0
.DSTRUCT xpmp_channel2,xpmp_channel_t,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0
.DSTRUCT xpmp_channel3,xpmp_channel_t,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0
xpmp_freqChange:	.db 0
xpmp_volChange: 	.db 0
xpmp_lastNote:		.db 0
xpmp_audioctl:		.db 0
xpmp_tempw:		.dw 0
XPMP_VARIABLES_END:


.MACRO ADD_M16_IMM8
	.16bit
	lda	\1
	clc
	adc	#\2
	sta	\1
	lda	\1+1
	adc	#0
	sta	\1+1
	.8bit
.ENDM


.MACRO ADD_M16_M16
	.16bit
	lda	\1
	clc
	adc	\2
	sta	\1
	lda	\1+1
	adc	\2+1
	sta	\1+1
	.8bit
.ENDM


.MACRO ADD_M16_M16_ZP
	lda	\1
	clc
	adc	\2
	sta	\1
	lda	\1+1
	adc	\2+1
	sta	\1+1
.ENDM


; Initialize the music player
; $03..$04 = pointer to song table, $05 = song number
xpmp_init:
	dec		xpmp_songNum
	asl		xpmp_songNum
	clc
	lda		xpmp_songTbl
	adc		xpmp_songNum
	sta		xpmp_songTbl
	lda		xpmp_songTbl+1
	adc		#0
	sta		xpmp_songTbl+1
	
	; Initialize all the player variables to zero
	lda		#0
	ldy		#(XPMP_VARIABLES_END - XPMP_VARIABLES)
	ldx		#0
	xpmp_init_zero:
	sta		XPMP_VARIABLES.w,x
	inx
	dey
	bne		xpmp_init_zero
		
	; Initialize channel data pointers
	.IFDEF XPMP_ENABLE_CHANNEL_A
	ldy	#0
	lda	(xpmp_songTbl),y
	sta	xpmp_channel0.dataPtr.w
	iny
	lda	(xpmp_songTbl),y
	sta	xpmp_channel0.dataPtr.w+1
	.ENDIF	
	.IFDEF XPMP_ENABLE_CHANNEL_B
	ldy	#2
	lda	(xpmp_songTbl),y
	sta	xpmp_channel1.dataPtr.w
	iny
	lda	(xpmp_songTbl),y
	sta	xpmp_channel1.dataPtr.w+1
	.ENDIF	
	.IFDEF XPMP_ENABLE_CHANNEL_C
	ldy	#4
	lda	(xpmp_songTbl),y
	sta	xpmp_channel2.dataPtr.w
	iny
	lda	(xpmp_songTbl),y
	sta	xpmp_channel2.dataPtr.w+1
	.ENDIF	
	.IFDEF XPMP_ENABLE_CHANNEL_D
	ldy	#6
	lda	(xpmp_songTbl),y
	sta	xpmp_channel3.dataPtr.w
	iny
	lda	(xpmp_songTbl),y
	sta	xpmp_channel3.dataPtr.w+1
	.ENDIF	

	; Initialize loop pointers
	lda	#$FF
	.IFDEF XPMP_ENABLE_CHANNEL_A
	sta	xpmp_channel0.loopIdx.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_B
	sta	xpmp_channel1.loopIdx.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_C
	sta	xpmp_channel2.loopIdx.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_D
	sta	xpmp_channel3.loopIdx.w
	.ENDIF

	; Initialize the delays for all channels to 1
	lda 	#1
	.IFDEF XPMP_ENABLE_CHANNEL_A
	sta	xpmp_channel0.delay.w+1
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_B
	sta	xpmp_channel1.delay.w+1
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_C
	sta	xpmp_channel2.delay.w+1
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_D
	sta	xpmp_channel3.delay.w+1
	.ENDIF

	; Turn on frequency dividers for all channels
	lda 	#$00 
	.IFDEF XPMP_ENABLE_CHANNEL_A
	sta	xpmp_channel0.audc.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_B
	sta	xpmp_channel1.audc.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_C
	sta	xpmp_channel2.audc.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_D
	sta	xpmp_channel3.audc.w
	.ENDIF

	; Set 64 kHz clocks for all channels
	lda 	#2
	.IFDEF XPMP_ENABLE_CHANNEL_A
	sta	xpmp_channel0.mode.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_B
	sta	xpmp_channel1.mode.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_C
	sta	xpmp_channel2.mode.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_D
	sta	xpmp_channel3.mode.w
	.ENDIF
	
	; Clear all sound registers
	lda		#0
	sta		$D200
	sta		$D201
	sta		$D202
	sta		$D203
	sta		$D204
	sta		$D205
	sta		$D206
	sta		$D207
	sta		$D208
	
	rts


; Code duplication ahoy!

.macro XPMP_COMMANDS

; X contains the command byte
; Y contains zero
xpmp_\1_cmd_00:
	txa
	cmp		#CMD_VOLUP
	bne		xpmp_\1_cmd_60
	;lda		xpmp_modevol.w
	;and		#$F0
	;sta		xpmp_modevol.w
	iny
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	lda		xpmp_channel\1.volume.w
	clc
	adc		(xpmp_dataPtr),y
	sta		xpmp_channel\1.volume.w
	;ora		xpmp_modevol.w
	;sta		xpmp_modevol.w
	lda		#1
	sta		xpmp_volChange.w		; Volume has changed
	lda		#EFFECT_DISABLED
	sta		xpmp_channel\1.vMac.w		; Volume set overrides volume macros
	rts
	
xpmp_\1_cmd_60:

	lda		xpmp_channel\1.note.w
	sta		xpmp_lastNote.w
	txa	
	and		#$0F
	sta		xpmp_channel\1.note.w
	txa
	and		#$F0
	cmp		#CMD_NOTE2
	beq		xpmp_\1_cmd_00_std_delay
	ADD_M16_IMM8 xpmp_channel\1.dataPos,2
	iny
	lda		(xpmp_dataPtr),y
	bpl		xpmp_\1_cmd_00_short_note
		tax
		iny
		ADD_M16_IMM8 xpmp_channel\1.dataPos,1
		txa
		and		#$7F
		lsr		a
		tax
		ror		a
		and		#$80
		ora		(xpmp_dataPtr),y
		pha
		iny
		lda		(xpmp_dataPtr),y
		clc
		adc		xpmp_channel\1.delay.w
		sta		xpmp_channel\1.delay.w		; Fractional part
		pla
		adc		#0
		sta		xpmp_channel\1.delay.w+1
		txa
		adc		#0
		sta		xpmp_channel\1.delay.w+2	; Whole part
		jmp		xpmp_\1_cmd_00_got_delay
	xpmp_\1_cmd_00_short_note:	
	tax
	iny
	lda		(xpmp_dataPtr),y
	clc
	adc		xpmp_channel\1.delay.w
	sta		xpmp_channel\1.delay.w		; Fractional part
	txa
	adc		#0
	beq		xpmp_\1_note_ret
	sta		xpmp_channel\1.delay.w+1
	lda		#0
	adc		#0
	sta		xpmp_channel\1.delay.w+2	; Whole part
	jmp		xpmp_\1_cmd_00_got_delay
	xpmp_\1_cmd_00_std_delay:
	lda		xpmp_channel\1.delay.w
	clc
	adc		xpmp_channel\1.delayLatch.w
	sta		xpmp_channel\1.delay.w
	lda		#0
	adc		xpmp_channel\1.delayLatch.w+1
	sta		xpmp_channel\1.delay.w+1
	lda		#0
	adc		xpmp_channel\1.delayLatch.w+2
	sta		xpmp_channel\1.delay.w+2
	xpmp_\1_cmd_00_got_delay:
	lda		#2
	sta		xpmp_freqChange.w
	lda		xpmp_channel\1.note.w
	cmp		#CMD_REST
	beq		xpmp_\1_note_ret
	cmp		#CMD_REST2
	beq		xpmp_\1_note_ret
	
	.IFNDEF XPMP_DTMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_DM
	lda		xpmp_channel\1.dtMac.w
	beq		+
	jsr		xpmp_\1_reset_dt_mac
	+:
	;.ENDIF
	.ENDIF
	.IFNDEF XPMP_VMAC_NOT_USED
	lda		xpmp_channel\1.vMac.w
	beq		+
	jsr		xpmp_\1_reset_v_mac
	+:
	.ENDIF
	.IFNDEF XPMP_ENMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_EN
	lda		xpmp_channel\1.enMac.w
	beq		+
	jsr		xpmp_\1_reset_en_mac
	+:
	;.ENDIF
	.ENDIF
	.IFNDEF XPMP_MPMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_MP
	lda		xpmp_channel\1.mpMac.w
	beq		+
	jsr		xpmp_\1_reset_mp_mac
	+:
	;.ENDIF
	.ENDIF
	.IFNDEF XPMP_EPMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_EP
	lda		xpmp_channel\1.epMac.w
	beq		+
	jsr		xpmp_\1_reset_ep_mac
	+:
	;.ENDIF
	.ENDIF
	xpmp_\1_note_ret:
	rts


; Set octave
xpmp_\1_cmd_10:
	dex
	txa
	and		#$0F
	asl		a
	asl		a
	sta		xpmp_channel\1.octave.w
	asl		a
	clc
	adc		xpmp_channel\1.octave.w
	sta		xpmp_channel\1.octave.w		; Multiplied by 12
	rts	


; Set distortion	
xpmp_\1_cmd_20:
	lda		xpmp_channel\1.audc.w
	and		#$1F
	sta		xpmp_channel\1.audc.w
	txa
	and		#7
	asl		a
	asl		a
	asl		a
	asl		a
	asl		a
	ora		xpmp_channel\1.audc.w
	sta		xpmp_channel\1.audc.w
	lda		#0
	sta		xpmp_channel\1.dtMac.w
	rts


; Set volume (short)
xpmp_\1_cmd_30:
	txa
	and		#$0F
	sta		xpmp_channel\1.volume.w
	lda		#1
	sta		xpmp_volChange.w			; Volume has changed
	lda		#EFFECT_DISABLED
	sta		xpmp_channel\1.vMac.w		; Volume set overrides volume macros
	rts

	
; Octave up + note	
xpmp_\1_cmd_40:
	lda		xpmp_channel\1.octave.w
	clc
	adc		#12
	sta		xpmp_channel\1.octave.w
	txa
	clc
	adc 	#$20
	tax
	jmp		xpmp_\1_cmd_60


; Octave down + note
xpmp_\1_cmd_50:
	lda		xpmp_channel\1.octave.w
	clc
	adc		#$F4
	sta		xpmp_channel\1.octave.w
	txa
	clc
	adc 	#$10
	tax
	jmp		xpmp_\1_cmd_60


xpmp_\1_cmd_70:
xpmp_\1_cmd_80:
	rts

	
xpmp_\1_cmd_90:
	txa
	cmp		#CMD_ARPOFF
	bne		+

	; Turn off arpeggio macro
	lda		#EFFECT_DISABLED
	sta		xpmp_channel\1.enMac.w
	sta		xpmp_channel\1.noteOffs.w
	rts

	+:
	cmp		#CMD_FILTER
	bne		+
	; Set filter
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	iny
	lda		xpmp_audioctl.w
	.IF \1 == 0
	and		#$FB
	.ENDIF
	.IF \1 == 1
	and		#$FD
	.ENDIF
	sta		xpmp_audioctl.w
	lda		(xpmp_dataPtr),y
	beq		filter_off_\1
	and		#1
	.IF \1 == 0
	asl		a
	asl		a
	.ENDIF
	.IF \1 == 1
	asl		a
	.ENDIF
	.IF \1 < 2
	ora		xpmp_audioctl.w
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	.ENDIF
	rts
	filter_off_\1:
	.IF	\1 < 2
	lda		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	.ENDIF
	rts
	
	+:
	cmp	#CMD_JSR
	bne	+
	; Jump to pattern
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	lda		xpmp_channel\1.dataPos.w
	sta		xpmp_channel\1.oldPos.w
	lda		xpmp_channel\1.dataPos.w+1
	sta		xpmp_channel\1.oldPos.w+1
	lda		xpmp_channel\1.dataPtr.w
	sta		xpmp_channel\1.returnAddr.w
	lda		xpmp_channel\1.dataPtr.w+1
	sta		xpmp_channel\1.returnAddr.w+1
	iny
	lda		(xpmp_dataPtr),y
	asl		a
	tax
	lda		xpmp_pattern_tbl.w,x
	sta		xpmp_channel\1.dataPtr.w
	lda		xpmp_pattern_tbl.w+1,x
	sta		xpmp_channel\1.dataPtr.w+1
	lda		#$FF
	sta		xpmp_channel\1.dataPos.w
	sta		xpmp_channel\1.dataPos.w+1
	rts

	+:
	cmp		#CMD_RTS
	bne		+
	; Return from a pattern
	lda		xpmp_channel\1.returnAddr.w
	sta		xpmp_channel\1.dataPtr.w
	lda		xpmp_channel\1.returnAddr.w+1
	sta		xpmp_channel\1.dataPtr.w+1
	lda		xpmp_channel\1.oldPos.w
	sta		xpmp_channel\1.dataPos.w
	lda		xpmp_channel\1.oldPos.w+1
	sta		xpmp_channel\1.dataPos.w+1
	rts
	
	+:
	cmp		#CMD_LEN
	bne		+
	; Set note length
	ADD_M16_IMM8 xpmp_channel\1.dataPos,2
	iny
	lda	(xpmp_dataPtr),y
	bpl	xpmp_\1_cmd_90_short_delay
		tax
		iny
		ADD_M16_IMM8 xpmp_channel\1.dataPos,1
		txa
		and	#$7F
		lsr	a
		tax
		ror	a
		and	#$80
		ora	(xpmp_dataPtr),y
		sta	xpmp_channel\1.delayLatch.w+1
		iny
		lda	(xpmp_dataPtr),y
		sta	xpmp_channel\1.delayLatch.w		; Fractional part
		txa
		sta	xpmp_channel\1.delayLatch.w+2	; Whole part
		rts
	xpmp_\1_cmd_90_short_delay:
	sta	xpmp_channel\1.delayLatch.w+1
	iny
	lda	(xpmp_dataPtr),y
	sta	xpmp_channel\1.delayLatch.w		; Fractional part
	lda	#0
	sta	xpmp_channel\1.delayLatch.w+2	
	rts
	
	+:
	cmp		#CMD_WRMEM
	bne		+
	ADD_M16_IMM8 xpmp_channel\1.dataPos,3
	iny	
	lda		(xpmp_dataPtr),y
	sta		xpmp_tempZp1
	iny
	lda		(xpmp_dataPtr),y
	sta		xpmp_tempZp2
	iny
	lda		(xpmp_dataPtr),y
	ldy		#0
	sta		(xpmp_tempZp1),y
	rts
	
	; No ports for you. NEXT!
	+:
	cmp		#CMD_WRPORT
	bne		+
	ADD_M16_IMM8 xpmp_channel\1.dataPos,3
	rts
	
	
	+:
	rts
	

; Mode	
xpmp_\1_cmd_A0:
	txa
	and		#15
	.IF \1 < 2
	cmp		#1
	bne		+
	asl		a
	asl		a
	ora		xpmp_channel\1.mode.w
	sta		xpmp_channel\1.mode.w
	lda		xpmp_audioctl.w
	ora		#$10				; Combine channels A + B
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	rts
	+:
	lda		xpmp_channel\1.mode.w
	and		#3
	sta		xpmp_channel\1.mode.w
	lda		xpmp_audioctl.w
	and		#$EF				; Break connection between channel A + B
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	.ENDIF
	.IF \1 > 1
	cmp		#1
	bne		+
	asl		a
	asl		a
	ora		xpmp_channel\1.mode.w
	sta		xpmp_channel\1.mode.w
	lda		xpmp_audioctl.w
	ora		#$08				; Combine channels C + D
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	rts
	+:
	lda		xpmp_channel\1.mode.w
	and		#3
	sta		xpmp_channel\1.mode.w
	lda		xpmp_audioctl.w
	and		#$F7				; Break connection between channel C + D
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	.ENDIF
	rts
	
xpmp_\1_cmd_B0:
xpmp_\1_cmd_C0:
xpmp_\1_cmd_D0:
	rts


xpmp_\1_cmd_E0:
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	txa

	cmp		#CMD_CBOFF
	beq		xpmp_\1_cmd_Ex_cboff
	cmp		#CMD_CBONCE
	beq		xpmp_\1_cmd_Ex_cbonce
	cmp		#CMD_CBEVNT
	beq		xpmp_\1_cmd_Ex_cbevnt
	cmp		#CMD_DETUNE
	beq		xpmp_\1_cmd_Ex_detune
	cmp		#CMD_MULT
	beq		xpmp_\1_cmd_Ex_mult
	rts

	xpmp_\1_cmd_Ex_cboff:
	lda		#0
	sta		xpmp_channel\1.cbEvnote.w
	sta		xpmp_channel\1.cbEvnote.w+1
	rts
	
	xpmp_\1_cmd_Ex_cbonce:
	rts
	
	xpmp_\1_cmd_Ex_cbevnt:
	rts
	
	xpmp_\1_cmd_Ex_detune:
	iny
	lda		(xpmp_dataPtr),y
	sta		xpmp_channel\1.detune.w
	ldx		#0
	and		#$80
	beq		xpmp_\1_cmd_Ex_detune_pos
	ldx		#$FF
	xpmp_\1_cmd_Ex_detune_pos:
	stx		xpmp_channel\1.detune.w+1
	rts
	
	xpmp_\1_cmd_Ex_mult:
	iny
	lda		(xpmp_dataPtr),y
	and		#3
	sta		xpmp_tempw.w
	lda		xpmp_channel\1.mode.w
	and 	#4
	ora		xpmp_tempw.w
	sta		xpmp_channel\1.mode.w
	and		#3
	cmp		#1
	bne		+
	; 15 kHz
	lda		xpmp_audioctl.w
	.IF \1 < 2
	and		#$BF
	.ENDIF
	.IF \1 > 1
	and		#$DF
	.ENDIF
	ora		#1
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	rts
	+:
	cmp		#3
	bne		+
	; CPU clock
	.IF \1 < 2
	lda		xpmp_audioctl.w
	ora		#$40
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	.ENDIF
	.IF \1 > 1
	lda		xpmp_audioctl.w
	ora		#$20
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	.ENDIF
	rts
	+:
	; 64 kHz
	lda		xpmp_audioctl.w
	and		#$FE
	.IF \1 < 2
	and		#$BF
	.ENDIF
	.IF \1 > 1
	and		#$DF
	.ENDIF
	sta		xpmp_audioctl.w
	sta		XPMP_AUDIOCTL
	rts
	
	
xpmp_\1_cmd_F0:
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	txa
	
	cmp		#CMD_JMP
	beq		xpmp_\1_cmd_Fx_jmp
	cmp		#CMD_DJNZ
	beq		xpmp_\1_cmd_Fx_djnz
	cmp		#CMD_LOPCNT
	beq		xpmp_\1_cmd_Fx_lopcnt
	cmp		#CMD_END
	beq		xpmp_\1_cmd_Fx_end
	cmp		#CMD_J1
	beq		xpmp_\1_cmd_Fx_j1
	cmp		#CMD_VOLMAC
	beq		xpmp_\1_cmd_Fx_volmac
	jmp		Fx_\1_part2

	xpmp_\1_cmd_Fx_volmac:
	.IFNDEF XPMP_VMAC_NOT_USED
	iny
	lda		(xpmp_dataPtr),y
	sta		xpmp_channel\1.vMac.w
	beq		xpmp_\1_vmac_off
	xpmp_\1_reset_v_mac:
	asl		a
	tax
	dex
	dex
	lda		xpmp_v_mac_tbl.w,x
	sta		xpmp_channel\1.vMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_v_mac_tbl.w+1,x
	sta		xpmp_channel\1.vMacPtr.w+1
	sta		xpmp_tempZp2
	ldy		#0
	lda		(xpmp_tempZp1),y
	sta		xpmp_channel\1.volume.w
	lda		#1
	sta		xpmp_channel\1.vMacPos.w
	rts
	xpmp_\1_vmac_off:
	;sta		xpmp_channel\1.noteOffs.w
	.ENDIF
	rts

	xpmp_\1_cmd_Fx_djnz:
	ldx		xpmp_channel\1.loopIdx.w
	dec		xpmp_channel\1.loop1.w,x
	bne		xpmp_\1_cmd_Fx_jmp
	dec		xpmp_channel\1.loopIdx.w
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	rts
	
	xpmp_\1_cmd_Fx_lopcnt:
	iny
	lda		(xpmp_dataPtr),y
	inc		xpmp_channel\1.loopIdx.w
	ldx		xpmp_channel\1.loopIdx.w
	sta		xpmp_channel\1.loop1.w,x
	rts

	xpmp_\1_cmd_Fx_jmp:
	iny
	lda		(xpmp_dataPtr),y
	sta		xpmp_channel\1.dataPos.w
	iny	
	lda		(xpmp_dataPtr),y
	sta		xpmp_channel\1.dataPos.w+1
	dec		xpmp_channel\1.dataPos.w	; dataPos will be increased after the return, so we decrease it here
	lda		#$FF
	cmp		xpmp_channel\1.dataPos.w
	bne		+
	dec		xpmp_channel\1.dataPos.w+1
	+:
	rts
	
	xpmp_\1_cmd_Fx_end:
	sta		xpmp_channel\1.note.w
	lda		#2
	sta		xpmp_freqChange.w
	rts
	
	xpmp_\1_cmd_Fx_j1:
	lda		xpmp_channel\1.loopIdx.w
	cmp		#1

	bne		+
	dec		xpmp_channel\1.loopIdx.w
	jmp		xpmp_\1_cmd_Fx_jmp
	+:
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	rts
	
	xpmp_\1_cmd_Fx_dutmac:
	.IFNDEF XPMP_DTMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_DM
	iny
	lda		(xpmp_dataPtr),y
	sta		xpmp_channel\1.dtMac.w
	beq		xpmp_\1_dutmac_off
	xpmp_\1_reset_dt_mac:
	asl		a
	tax
	dex
	dex
	lda		xpmp_channel\1.audc.w
	and		#$1F
	sta		xpmp_channel\1.audc.w
	lda		xpmp_dt_mac_tbl.w,x
	sta		xpmp_channel\1.dtMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_dt_mac_tbl.w+1,x
	sta		xpmp_channel\1.dtMacPtr.w+1
	sta		xpmp_tempZp2
	ldx		#0
	lda		(xpmp_tempZp1,x)
	and 	#7
	asl		a
	asl		a
	asl		a
	asl		a
	asl		a
	ora		xpmp_channel\1.audc.w
	sta		xpmp_channel\1.audc.w
	lda		#1
	sta		xpmp_channel\1.dtMacPos.w
	xpmp_\1_dutmac_off:
	;.ENDIF
	.ENDIF
	rts

	Fx_\1_part2:
	cmp		#CMD_DUTMAC
	beq		xpmp_\1_cmd_Fx_dutmac
	cmp		#CMD_ARPMAC
	beq		xpmp_\1_cmd_Fx_arpmac
	cmp		#CMD_SWPMAC
	beq		xpmp_\1_cmd_Fx_swpmac
	cmp		#CMD_VIBMAC
	beq		xpmp_\1_cmd_Fx_vibmac
	rts	
	
	xpmp_\1_cmd_Fx_vibmac:
	.IFNDEF XPMP_MPMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_MP
	iny
	lda		(xpmp_dataPtr),y
	sta		xpmp_channel\1.mpMac.w
	beq		xpmp_\1_mpmac_off
	xpmp_\1_reset_mp_mac:
	asl		a
	tax
	dex
	dex
	lda		xpmp_MP_mac_tbl.w,x
	sta		xpmp_channel\1.mpMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_MP_mac_tbl.w+1,x
	sta		xpmp_channel\1.mpMacPtr.w+1
	sta		xpmp_tempZp2
	ldy		#0
	lda		(xpmp_tempZp1),y
	sta		xpmp_channel\1.mpMacDelay.w
	iny
	iny
	lda		(xpmp_tempZp1),y
	sta		xpmp_channel\1.freqOffsLatch.w
	lda		#0
	sta		xpmp_channel\1.freqOffsLatch.w+1
	ADD_M16_IMM8 xpmp_channel\1.mpMacPtr,1
	rts
	xpmp_\1_mpmac_off:
	sta		xpmp_channel\1.freqOffs.w
	sta		xpmp_channel\1.freqOffs.w+1
	;.ENDIF
	.ENDIF
	rts

	xpmp_\1_cmd_Fx_arpmac:
	;.IFNDEF XPMP_ENMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_EN
	iny
	lda		(xpmp_dataPtr),y
	sta		xpmp_channel\1.enMac.w
	beq		xpmp_\1_arpmac_off
	xpmp_\1_reset_en_mac:
	asl		a
	tax
	dex
	dex
	lda		xpmp_EN_mac_tbl.w,x
	sta		xpmp_channel\1.enMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_EN_mac_tbl.w+1,x
	sta		xpmp_channel\1.enMacPtr.w+1
	sta		xpmp_tempZp2
	ldy		#0
	lda		(xpmp_tempZp1),y
	sta		xpmp_channel\1.noteOffs.w
	lda		#1
	sta		xpmp_channel\1.enMacPos.w
	rts
	xpmp_\1_arpmac_off:
	sta		xpmp_channel\1.noteOffs.w
	;.ENDIF
	;.ENDIF
	rts
	
	xpmp_\1_cmd_Fx_swpmac:
	.IFNDEF XPMP_EPMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_EP
	iny
	lda		(xpmp_dataPtr),y
	sta		xpmp_channel\1.epMac.w
	beq		xpmp_\1_epmac_off
	xpmp_\1_reset_ep_mac:
	asl		a
	tax
	dex
	dex
	lda		xpmp_EP_mac_tbl.w,x
	sta		xpmp_channel\1.epMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_EP_mac_tbl.w+1,x
	sta		xpmp_channel\1.epMacPtr.w+1
	sta		xpmp_tempZp2
	ldy		#0
	lda		(xpmp_tempZp1),y
	sta		xpmp_channel\1.freqOffs.w
	cmp		#$80
	beq		+
	lda		#$FF
	+:
	sta		xpmp_channel\1.freqOffs.w+1
	lda		#1
	sta		xpmp_channel\1.epMacPos.w
	rts
	xpmp_\1_epmac_off:
	sta		xpmp_channel\1.freqOffs.w
	sta		xpmp_channel\1.freqOffs.w+1
	;.ENDIF
	.ENDIF
	rts
	
.ENDM


.MACRO XPMP_UPDATE_FUNC 

xpmp_\1_update:
	lda		#0
	sta		xpmp_freqChange.w
	sta		xpmp_volChange.w

	lda	xpmp_channel\1.note.w
	cmp		#CMD_END
	bne		+
	rts					; Playback has ended for this channel - all processing should be skipped
	+:
	
	dec		xpmp_channel\1.delay.w+1
	lda		#$FF
	cmp		xpmp_channel\1.delay.w+1
	bne		+
	dec		xpmp_channel\1.delay.w+2
	+:
	lda		xpmp_channel\1.delay.w+1
	ora		xpmp_channel\1.delay.w+2
	bne		xpmp_\1_update_effects
	
	jsr		xpmp_\1_read_commands
	rts
	
	xpmp_\1_update_effects:
	.IFNDEF XPMP_VMAC_NOT_USED
	lda		xpmp_channel\1.vMac.w
	beq		xpmp_update_\1_v_done
	xpmp_update_\1_v:
	lda		#1
	sta		xpmp_volChange.w
	lda		xpmp_channel\1.vMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_channel\1.vMacPtr.w+1
	sta		xpmp_tempZp2
	ldy		xpmp_channel\1.vMacPos.w
	lda		(xpmp_tempZp1),y
	cmp		#$80
	beq		xpmp_update_\1_v_loop
	sta		xpmp_channel\1.volume.w
	inc		xpmp_channel\1.vMacPos.w
	jmp		xpmp_update_\1_v_done
	xpmp_update_\1_v_loop:
	lda		xpmp_channel\1.vMac.w
	asl		a
	tax
	dex
	dex
	lda		xpmp_v_mac_loop_tbl.w,x
	sta		xpmp_channel\1.vMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_v_mac_loop_tbl.w+1,x
	sta		xpmp_channel\1.vMacPtr.w+1
	sta		xpmp_tempZp2
	lda		#1
	sta		xpmp_channel\1.vMacPos.w
	ldx		#0
	lda		(xpmp_tempZp1,x)
	sta		xpmp_channel\1.volume.w
	xpmp_update_\1_v_done:
	.ENDIF
	
	.IFNDEF XPMP_ENMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_EN
	lda		xpmp_channel\1.enMac.w
	beq		xpmp_update_\1_EN_done
	xpmp_update_\1_EN:
	lda		#1
	sta		xpmp_freqChange.w
	lda		xpmp_channel\1.enMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_channel\1.enMacPtr.w+1
	sta		xpmp_tempZp2
	ldy		xpmp_channel\1.enMacPos.w
	lda		(xpmp_tempZp1),y
	cmp		#$80
	beq		xpmp_update_\1_EN_loop
	clc
	adc		xpmp_channel\1.noteOffs.w
	sta		xpmp_channel\1.noteOffs.w
	inc		xpmp_channel\1.enMacPos.w
	jmp		xpmp_update_\1_EN_done
	xpmp_update_\1_EN_loop:
	lda		xpmp_channel\1.enMac.w
	asl		a
	tax
	dex
	dex
	lda		xpmp_EN_mac_loop_tbl.w,x
	sta		xpmp_channel\1.enMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_EN_mac_loop_tbl.w+1,x
	sta		xpmp_channel\1.enMacPtr.w+1
	sta		xpmp_tempZp2
	lda		#1
	sta		xpmp_channel\1.enMacPos.w
	ldx		#0
	lda		(xpmp_tempZp1,x)
	clc
	adc		xpmp_channel\1.noteOffs.w
	sta		xpmp_channel\1.noteOffs.w
	xpmp_update_\1_EN_done:
	;.ENDIF
	.ENDIF

	.IFNDEF XPMP_DTMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_DM
	lda		xpmp_channel\1.dtMac.w
	beq		xpmp_update_\1_DT_done
	xpmp_update_\1_DT:
	lda		xpmp_channel\1.audc.w
	and		#$1F
	sta		xpmp_channel\1.audc.w
	lda		#1
	sta		xpmp_volChange.w
	lda		xpmp_channel\1.dtMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_channel\1.dtMacPtr.w+1
	sta		xpmp_tempZp2
	ldy		xpmp_channel\1.dtMacPos.w
	lda		(xpmp_tempZp1),y
	cmp		#$80
	beq		xpmp_update_\1_DT_loop
	and		#7
	asl		a
	asl		a
	asl		a
	asl		a
	asl		a
	ora		xpmp_channel\1.audc.w
	sta		xpmp_channel\1.audc.w
	inc		xpmp_channel\1.dtMacPos.w
	jmp		xpmp_update_\1_DT_done
	xpmp_update_\1_DT_loop:
	lda		xpmp_channel\1.dtMac.w
	asl		a
	tax
	dex
	dex
	lda		xpmp_dt_mac_loop_tbl.w,x
	sta		xpmp_channel\1.dtMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_dt_mac_loop_tbl.w+1,x
	sta		xpmp_channel\1.dtMacPtr.w+1
	sta		xpmp_tempZp2
	lda		#1
	sta		xpmp_channel\1.dtMacPos.w
	ldx		#0
	lda		(xpmp_tempZp1,x)
	and		#7
	asl		a
	asl		a
	asl		a
	asl		a
	asl		a
	ora		xpmp_channel\1.audc.w
	sta		xpmp_channel\1.audc.w
	xpmp_update_\1_DT_done:
	;.ENDIF
	.ENDIF

	
	.IFNDEF XPMP_EPMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_EP
	lda		xpmp_channel\1.epMac.w
	beq		xpmp_update_\1_EP_done
	xpmp_update_\1_EP:
	lda		#1
	sta		xpmp_freqChange.w
	lda		xpmp_channel\1.epMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_channel\1.epMacPtr.w+1
	sta		xpmp_tempZp2
	ldy		xpmp_channel\1.epMacPos.w
	lda		(xpmp_tempZp1),y
	cmp		#$80
	beq		xpmp_update_\1_EP_loop
	sta		xpmp_tempZp1
	and		#$80
	beq		+
	lda		#$FF
	+:
	sta		xpmp_tempZp2
	ADD_M16_M16 xpmp_channel\1.freqOffs,xpmp_tempZp1
	inc		xpmp_channel\1.epMacPos.w
	jmp		xpmp_update_\1_EP_done
	xpmp_update_\1_EP_loop:
	lda		xpmp_channel\1.epMac.w
	asl		a
	tax
	dex
	dex
	lda		xpmp_EP_mac_loop_tbl.w,x
	sta		xpmp_channel\1.epMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_EP_mac_loop_tbl.w+1,x
	sta		xpmp_channel\1.epMacPtr.w+1
	sta		xpmp_tempZp2
	lda		#1
	sta		xpmp_channel\1.epMacPos.w
	ldx		#0
	lda		(xpmp_tempZp1,x)
	sta		xpmp_tempZp1
	and		#$80
	beq		+
	lda		#$FF
	+:
	sta		xpmp_tempZp2
	ADD_M16_M16 xpmp_channel\1.freqOffs,xpmp_tempZp1
	xpmp_update_\1_EP_done:
	;.ENDIF
	.ENDIF
	
	.IFNDEF XPMP_MPMAC_NOT_USED
	;.IFDEF XPMP_CHN\1_USES_MP
	; Vibrato
	lda 	xpmp_channel\1.mpMac.w
	beq 	xpmp_update_\1_MP_done
	ldx		xpmp_channel\1.mpMacDelay.w
	dex	
	bne		xpmp_update_\1_MP_done2
	xpmp_update_\1_MP:
	lda		#1
	sta		xpmp_freqChange.w		; Frequency has changed
	lda		xpmp_channel\1.mpMacPtr.w
	sta		xpmp_tempZp1
	lda		xpmp_channel\1.mpMacPtr.w+1
	sta		xpmp_tempZp2
	lda		xpmp_channel\1.freqOffsLatch.w
	sta		xpmp_channel\1.freqOffs.w
	eor		#$FF
	clc
	adc		#1
	sta		xpmp_channel\1.freqOffsLatch.w
	lda		xpmp_channel\1.freqOffsLatch.w+1
	sta		xpmp_channel\1.freqOffs.w+1
	eor		#$FF
	adc		#0
	sta		xpmp_channel\1.freqOffsLatch.w+1
	ldy		#0
	lda		(xpmp_tempZp1),y
	tax
	xpmp_update_\1_MP_done2:
	stx		xpmp_channel\1.mpMacDelay.w
	xpmp_update_\1_MP_done:
	;.ENDIF
	.ENDIF
	
	lda	xpmp_freqChange.w
	bne	xpmp_update_\1_freq_change
	jmp	xpmp_\1_update_set_vol
	
	rts
	

xpmp_\1_read_commands:
	lda		xpmp_channel\1.dataPtr.w
	clc
	adc		xpmp_channel\1.dataPos.w
	sta		xpmp_dataPtrLo
	lda		xpmp_channel\1.dataPtr.w+1
	adc		xpmp_channel\1.dataPos.w+1
	sta		xpmp_dataPtrHi
	ldy		#0
	lda		(xpmp_dataPtr),y		; Read the first byte of the command
	sta		xpmp_tempZp3
	lsr		a
	lsr		a
	lsr 	a
	and		#$FE
	tax	
	lda		xpmp_\1_jump_tbl.w,x
	sta		xpmp_tempw.w
	lda		xpmp_\1_jump_tbl.w+1,x
	sta		xpmp_tempw.w+1			; Get the command handler address and store it in xpmp_tempw
	lda		xpmp_tempZp3
	tax
	jsr		xpmp_call_indirect		; Jump to the command handler
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1

	lda		xpmp_freqChange.w
	cmp		#2				; Have we read a note/rest/end command?
	bne		xpmp_\1_read_commands
	
	xpmp_update_\1_freq_change:
	lda		xpmp_channel\1.note.w
	cmp		#CMD_REST2
	bne		xpmp_update_\1_check_rest
	jmp		xpmp_\1_rest2
	xpmp_update_\1_check_rest:
	cmp		#CMD_REST
	bne		xpmp_update_\1_check_end
	jmp		xpmp_\1_rest
	xpmp_update_\1_check_end:
	cmp		#CMD_END
	bne		xpmp_update_\1_cmd_ok
	jmp		xpmp_\1_rest
	xpmp_update_\1_cmd_ok:
	;lda	xpmp_channel\1.audc.w
	;sta	XPMP_AUDC1+\1*2
	xpmp_update_\1_freq_change_2:
	lda		xpmp_channel\1.note.w
	clc
	adc		xpmp_channel\1.noteOffs.w
	sta		xpmp_tempZp1
	lda		xpmp_channel\1.octave.w
	adc		xpmp_tempZp1
	asl		a
	tax
lda xpmp_channel\1.mode.w
.IF \1 == 1
cmp #7
bne +
lda xpmp_freq_tbl_cpu.w+1,x
sec 
sbc #3
sta	xpmp_channel\1.freq+1.w
lda xpmp_freq_tbl_cpu.w,x
sbc #0
sta	xpmp_channel\1.freq.w
jmp xpmp_update\1_got_freq
+:
cmp #3
bne +
lda xpmp_freq_tbl_cpu.w,x
sta	xpmp_channel\1.freq.w
lda xpmp_freq_tbl_cpu.w+1,x
sta	xpmp_channel\1.freq.w+1
jmp xpmp_update\1_got_freq
+:
.ENDIF
.IF \1 == 3
cmp #7
bne +
lda xpmp_freq_tbl_cpu.w+1,x
sec 
sbc #3
sta	xpmp_channel\1.freq+1.w
lda xpmp_freq_tbl_cpu.w,x
sbc #0
sta	xpmp_channel\1.freq.w
;lda #2
;sta xpmp_channel\1.volume.w
jmp xpmp_update\1_got_freq
+:
cmp #3
bne +
lda xpmp_freq_tbl_cpu.w,x
sta	xpmp_channel\1.freq.w
lda xpmp_freq_tbl_cpu.w+1,x
sta	xpmp_channel\1.freq.w+1
jmp xpmp_update\1_got_freq
+:
.ENDIF
cmp #1
bne +
lda xpmp_freq_tbl_15khz.w,x
sta	xpmp_channel\1.freq.w
lda #0
sta	xpmp_channel\1.freq.w+1
jmp xpmp_update\1_got_freq
+:
lda xpmp_freq_tbl_64khz.w,x
sta	xpmp_channel\1.freq.w
lda #0
sta	xpmp_channel\1.freq.w+1

xpmp_update\1_got_freq:
	; Add detune and freqOffs
	lda		xpmp_channel\1.detune.w
	sta		xpmp_tempZp1
	lda		xpmp_channel\1.detune.w+1
	sta		xpmp_tempZp2
	ADD_M16_M16 xpmp_tempZp1,xpmp_channel\1.freqOffs
	;ADD_M16_M16_ZP xpmp_tempZp1,xpmp_tempZp1
	ADD_M16_M16_ZP xpmp_tempZp1,xpmp_tempZp1
	lda xpmp_tempZp1
	eor #$FF
	sta xpmp_tempZp1
	lda xpmp_tempZp1+1
	eor #$FF
	sta xpmp_tempZp1+1
	inc xpmp_tempZp1
	bne +
	inc xpmp_tempZp1+1
	+:
	ADD_M16_M16 xpmp_channel\1.freq,xpmp_tempZp1
	
jmp xpmp_update_\1_freq_ok

	; Clip frequency if out of range
	lda		xpmp_channel\1.freq.w+1
	;cmp		#$01
	;bcc		xpmp_update_\1_freq_too_low
	bmi		xpmp_update_\1_freq_too_low
	;beq		xpmp_update_\1_freq_might_be_too_low
	cmp		#$FD
	beq		xpmp_update_\1_freq_might_be_too_high
	bcs		xpmp_update_\1_freq_too_high
	jmp		xpmp_update_\1_freq_ok

	xpmp_update_\1_freq_might_be_too_high:
	lda		xpmp_channel\1.freq.w
	cmp		#$24
	bcc		xpmp_update_\1_freq_ok
	xpmp_update_\1_freq_too_high:
	lda		#$23
	sta		xpmp_channel\1.freq.w
	lda		#$FD
	sta		xpmp_channel\1.freq.w+1
	jmp		xpmp_update_\1_freq_ok

	xpmp_update_\1_freq_might_be_too_low:
	lda		xpmp_channel\1.freq.w+1
	cmp		#$0C
	bcs		xpmp_update_\1_freq_ok
	xpmp_update_\1_freq_too_low:
	lda		#$0C
	sta		xpmp_channel\1.freq.w
	lda		#$01
	sta		xpmp_channel\1.freq.w+1
	
	xpmp_update_\1_freq_ok:
	lda		xpmp_channel\1.freq.w
	sta		XPMP_AUDF1+\1*2
	.IF \1 == 1
	lda		xpmp_channel\1.mode.w
	and		#4
	beq		+
	lda		xpmp_channel\1.freq.w+1
	sta		XPMP_AUDF1		; set freq for chn A
	+:
	.ENDIF
	.IF \1 == 3
	lda		xpmp_channel\1.mode.w
	and		#4
	beq		+
	lda		xpmp_channel\1.freq.w+1
	sta		XPMP_AUDF1+4	; set freq for chn C
	+:
	.ENDIF
	
	lda		xpmp_lastNote.w
	cmp		#CMD_REST
	bne		xpmp_\1_update_set_vol_2
	jmp		xpmp_\1_update_set_vol_3

	; Mute the channel 
	xpmp_\1_rest:
	lda		#0
	sta		XPMP_AUDC1+\1*2
	xpmp_\1_rest2:
	rts
	
	xpmp_\1_update_set_vol:
	lda		xpmp_channel\1.note.w
	cmp		#CMD_REST
	beq		xpmp_\1_rest
	xpmp_\1_update_set_vol_2:
	; Update the volume if it has changed
	lda		xpmp_volChange.w
	beq		xpmp_update_\1_no_vol_change
	xpmp_\1_update_set_vol_3:
	lda		xpmp_channel\1.volume.w
	;eor		#$0F
	ora		xpmp_channel\1.audc.w
	sta		XPMP_AUDC1+\1*2
	xpmp_update_\1_no_vol_change:
	rts
		


.ENDM

xpmp_call_indirect:
	jmp		(xpmp_tempw.w)
	

.IFDEF XPMP_ENABLE_CHANNEL_A
 XPMP_COMMANDS 0
 XPMP_UPDATE_FUNC 0
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
 XPMP_COMMANDS 1
 XPMP_UPDATE_FUNC 1
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
 XPMP_COMMANDS 2
 XPMP_UPDATE_FUNC 2
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_D
 XPMP_COMMANDS 3
 XPMP_UPDATE_FUNC 3
.ENDIF


xpmp_update:
.IFDEF XPMP_ENABLE_CHANNEL_A
	jsr 	xpmp_0_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
	jsr 	xpmp_1_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
	jsr 	xpmp_2_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_D
	jsr 	xpmp_3_update
.ENDIF
	rts


.MACRO XPMP_JUMP_TABLE
xpmp_\1_jump_tbl:
.dw xpmp_\1_cmd_00
.dw xpmp_\1_cmd_10
.dw xpmp_\1_cmd_20
.dw xpmp_\1_cmd_30
.dw xpmp_\1_cmd_40
.dw xpmp_\1_cmd_50
.dw xpmp_\1_cmd_60
.dw xpmp_\1_cmd_70
.dw xpmp_\1_cmd_80
.dw xpmp_\1_cmd_90
.dw xpmp_\1_cmd_A0
.dw xpmp_\1_cmd_B0
.dw xpmp_\1_cmd_C0
.dw xpmp_\1_cmd_D0
.dw xpmp_\1_cmd_E0
.dw xpmp_\1_cmd_F0
.ENDM


.IFDEF XPMP_ENABLE_CHANNEL_A
 XPMP_JUMP_TABLE 0
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
 XPMP_JUMP_TABLE 1
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
 XPMP_JUMP_TABLE 2
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_D
 XPMP_JUMP_TABLE 3
.ENDIF


; Octaves 1-12
xpmp_freq_tbl_15khz:
.dw $00EF,$00E2,$00D5,$00C9,$00BE,$00B3,$00A9,$009F,$0096,$008E,$0086,$007E	; Lowest playable note is C1
.dw $0077,$0070,$006A,$0064,$005E,$0059,$0054,$004F,$004B,$0046,$0042,$003F
.dw $003B,$0038,$0034,$0031,$002F,$002C,$0029,$0027,$0025,$0023,$0021,$001F
.dw $001D,$001B,$001A,$0018,$0017,$0015,$0014,$0013,$0012,$0011,$0010,$000F
.dw $000E,$000D,$000C,$000C,$000B,$000A,$000A,$0009,$0008,$0008,$0007,$0007	; Highest sane note is D5
.dw $0007,$0006,$0006,$0005,$0005,$0005,$0004,$0004,$0004,$0003,$0003,$0003
.dw $0003,$0003,$0002,$0002,$0002,$0002,$0002,$0002,$0001,$0001,$0001,$0001
.dw $0001,$0001,$0001,$0001,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000	; Highest playable note is A#9
.dw $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$FFFF
.dw $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
.dw $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF
.dw $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF

xpmp_freq_tbl_64khz:
.dw $03D0,$0399,$0366,$0335,$0307,$02DB,$02B2,$028B,$0267,$0244,$0223,$0205
.dw $01E8,$01CC,$01B2,$019A,$0183,$016D,$0159,$0145,$0133,$0122,$0111,$0102
.dw $00F3,$00E6,$00D9,$00CC,$00C1,$00B6,$00AC,$00A2,$0099,$0090,$0088,$0080	; Lowest playable note is C3
.dw $0079,$0072,$006C,$0066,$0060,$005B,$0055,$0051,$004C,$0048,$0044,$0040
.dw $003C,$0039,$0035,$0032,$002F,$002D,$002A,$0028,$0025,$0023,$0021,$001F
.dw $001E,$001C,$001A,$0019,$0017,$0016,$0015,$0013,$0012,$0011,$0010,$000F
.dw $000E,$000D,$000D,$000C,$000B,$000A,$000A,$0009,$0009,$0008,$0008,$0007	; Highest sane note is F7
.dw $0007,$0006,$0006,$0005,$0005,$0005,$0004,$0004,$0004,$0004,$0003,$0003
.dw $0003,$0003,$0002,$0002,$0002,$0002,$0002,$0002,$0001,$0001,$0001,$0001
.dw $0001,$0001,$0001,$0001,$0001,$0000,$0000,$0000,$0000,$0000,$0000,$0000	; Highest playable note is B11
.dw $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
.dw $FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF

xpmp_freq_tbl_cpu:
.dw $E669,$F463,$585E,$0C59,$0D54,$554F,$E14A,$AD46,$B542,$F63E,$6D3B,$1738	; Lowest playable note is C1 (16-bit channels)
.dw $F134,$F831,$2A2F,$842C,$042A,$A827,$6E25,$5423,$5821,$791F,$B51D,$0A1C
.dw $771A,$FA18,$9317,$4016,$0015,$D213,$B512,$A811,$AA10,$BB0F,$D80E,$030E
.dw $390D,$7B0C,$C80B,$1E0B,$7E0A,$E709,$5909,$D208,$5308,$DB07,$6A07,$FF06
.dw $9B06,$3C06,$E205,$8D05,$3D05,$F204,$AA04,$6704,$2804,$EC03,$B303,$7E03
.dw $4B03,$1C03,$EF02,$C502,$9D02,$7702,$5302,$3202,$1202,$F401,$D801,$BD01
.dw $A401,$8C01,$7501,$6001,$4C01,$3901,$2801,$1701,$0701,$F800,$EA00,$DC00	; Lowest playable note is A7 (8-bit channels)
.dw $D000,$C400,$B900,$AE00,$A400,$9B00,$9200,$8900,$8100,$7A00,$7300,$6C00
.dw $6600,$6000,$5A00,$5500,$5000,$4B00,$4700,$4300,$3F00,$3B00,$3700,$3400
.dw $3100,$2E00,$2B00,$2900,$2600,$2400,$2100,$1F00,$1D00,$1B00,$1A00,$1800
.dw $1600,$1500,$1400,$1200,$1100,$1000,$0F00,$0E00,$0D00,$0C00,$0B00,$0A00
.dw $0900,$0800,$0800,$0700,$0700,$0600,$0500,$0500,$0400,$0400,$0300,$0300	; Highest sane note is C#12. Highest playable note is B12





